"""
@author: luojunhui
返回预分配信息
"""
import json

from static.config import db_article


class PreResponse(object):
    """
    预匹配处理
    """

    def __init__(self, params, mysql_client):
        """
        输入trace_id, 返回trace_id所绑定的视频信息
        :param params:
        :param mysql_client:
        """
        self.trace_id = None
        self.params = params
        self.mysql_client = mysql_client

    def checkParams(self):
        """
        校验参数
        :return:
        """
        try:
            self.trace_id = self.params['traceId']
            return None
        except Exception as e:
            response = {
                "error": "params check failed",
                "info": str(e)
            }
            return response

    async def findVideoInfo(self):
        """

        :return:
        """
        sql = f"""
        select video_info1, video_info2, video_info3 from {db_article}
        where trace_id = '{self.trace_id}';
        """
        video_info = await self.mysql_client.async_select(sql)
        video_info_list = video_info[0]
        vid_list = [json.loads(i) for i in video_info_list]
        return vid_list

    async def deal(self):
        """
        deal function
        :return:
        """
        params_error = self.checkParams()
        if params_error:
            return params_error
        else:
            video_info_list = await self.findVideoInfo()
            response = {
                "traceId": self.trace_id,
                "videoObjList": video_info_list
            }
            return response
